

#include "database.h"

extern int  _explore_class_field(Class_field *class_p);
extern int  _explore_number_field(Number_field *num_p);
extern int  _insert_to_field(char *class,char *firstname,char *lastname,int number);
extern Class_field  *_insert_to_class_field(Class_field *class_p,char *class);
extern Number_field *_insert_to_number_field(Number_field *num_p,char *firstname,char *lastname,int number);
extern Class_field  *_allocate_class(void);
extern Number_field *_allocate_number(void);
extern int  _read_file(char *item,int size,FILE *fp);
extern int  _search_class_field(Class_field *class_p,unsigned value,char *firstname,char *lastname);
extern int  _search_number_field(Number_field *num_p,unsigned value,char *firstname,char *lastname);
extern int  _free_field(Class_field *class_p);
extern int  _free_number_field(Number_field *num_p);
extern void _create_modem_setting_file(void);


int file_open(char *path,File_open_type type)
{
	char buf[256];
	FILE *fp;
	
	switch(type) {
	case FILE_OPEN_NEW:
		fp = fopen(path,"w");
		if(fp == NULL) {
			notice("Failed opening new file.\nCanceled.",NOTICE_TYPE_OK,"Dismiss","");
			fclose(fp);
			return FALSE;
		}
		fprintf(fp,HOT_FILE_KEY);
		fflush(fp);
		fclose(fp);
		
		_free_field(class_head);
		list_clear(Hot_parent->classlist);
		list_clear(Hot_parent->entrylist);
		strcpy(current_file,path);
				
		break;
		
	case FILE_OPEN_EXISTING:
		fp = fopen(path,"r+");
		if(fp == NULL) {
			notice("Failed opening file.\nCanceled.",NOTICE_TYPE_OK,"Dismiss","");
			fclose(fp);
			return FALSE;
		}
		
		fscanf(fp,HOT_FILE_KEY_FORMAT,buf);
		if(strcmp(HOT_FILE_KEY,buf)) {
			notice("This file is NOT hotpage file.\nCanceled.",NOTICE_TYPE_OK,"Dismiss","");
			fclose(fp);
			return FALSE;
		}
		
		fclose(fp);
		
		strcpy(current_file,path);
				
		class_listup();
		
		break;
	}
	
	return TRUE;
}


void class_listup(void)
{
	int number;
	Person_information info; /* Temporary */
	number = 1;
	
	_free_field(class_head);
	class_head = NULL;
	
	list_clear(Hot_parent->classlist);
	
	while(read_info(number,&info) != EOF) {
		if(info.number < 0) {
			number++;
			continue;
		}		
		_insert_to_field(info.class,info.first,info.last,number);
		number++;
	}

	_explore_class_field(class_head);
}

int  _explore_class_field(Class_field *class_p)
{
	if(class_p == NULL) 
		return TRUE;
	
	if(class_p->forward != NULL) 
		_explore_class_field(class_p->forward);

	classlist_insert(Hot_parent->classlist,class_p->class);

	if(class_p->backward != NULL)
		_explore_class_field(class_p->backward);
	
	return TRUE;
}

void entry_listup(char *class)
{
	Class_field *class_p;
	Number_field *num_p;
	class_p = class_head;
	
	list_clear(Hot_parent->entrylist);
	
	while( strcmp(class,class_p->class) != 0) {
		if(strcmp(class,class_p->class) < 0) {
			class_p = class_p->forward;
			continue;
		}
		class_p = class_p->backward;
	}
	
	xv_set(Hot_parent->entrylist,XV_SHOW,FALSE,NULL);
	_explore_number_field(class_p->num_p);
	xv_set(Hot_parent->entrylist,XV_SHOW,TRUE,NULL);
}


int  _explore_number_field(Number_field *num_p)
{
	if(num_p->forward != NULL) 
		_explore_number_field(num_p->forward);
		
	entrylist_insert(Hot_parent->entrylist,num_p->first,num_p->last,num_p->number);
	
	if(num_p->backward != NULL)
		_explore_number_field(num_p->backward);
	
	return TRUE;
}

int entry_update(Person_information *update_info,Update_type type)
{
	int number;
	Person_information info;
		
	number = 1;
	
	switch(type) {
	case UPDATE_NEW:
	case UPDATE_NEW_MORE:
		while(read_info(number,&info) != EOF) {
			if(info.number < 0)
				break;
			number++;
		} 
		
		update_info->number = number;
				
		if(update_info->number >= 100000000) {
				notice("Current file is full.\nUpdate canceled.",NOTICE_TYPE_OK,"Dismiss","");
				return FALSE;
		}
		
		write_info(update_info);
		
		list_clear(Hot_parent->classlist);
		_insert_to_field(update_info->class,update_info->first,update_info->last,update_info->number);
		_explore_class_field(class_head);
		
		break;
		
	case UPDATE_EDIT:
		write_info(update_info);
		
		class_listup();
					
		break;
	}
	
	return TRUE;
}	

int write_info(Person_information *info)
{
	FILE *fp;
	
	fp = fopen(current_file,"r+");
	
	fseek(fp,HOT_FILE_KEY_SIZE+HOT_FILE_REC_SIZE*(info->number - 1),SEEK_SET);
		
	fprintf(fp,HOT_FILE_FORMAT,info->number,info->first,info->last,
				info->class,info->countrycode,info->areacode,
				info->phone,info->fax,info->area,info->address,
				info->city,info->state,info->zip,info->country,
				info->email,info->notes[0],info->notes[1],
				info->notes[2],info->notes[3]);
	fflush(fp);
	
	fclose(fp);
}
	
int read_info(int number,Person_information *info)
{
	int i;
	char buf[256];
	FILE *fp;
	
	fp = fopen(current_file,"r+");
	
	fseek(fp,HOT_FILE_KEY_SIZE+HOT_FILE_REC_SIZE*(number - 1),SEEK_SET);
	
	if(_read_file(buf,9,fp) == EOF) {
		fclose(fp);
		return EOF;
	}
	info->number = atoi(buf);
	_read_file(info->first,20,fp); 
	_read_file(info->last,20,fp); 
	_read_file(info->class,20,fp);
	_read_file(info->countrycode,10,fp); 
	_read_file(info->areacode,10,fp);
	_read_file(info->phone,15,fp);
	_read_file(info->fax,15,fp);
	_read_file(buf,1,fp); info->area = atoi(buf);
	_read_file(info->address,40,fp);
	_read_file(info->city,40,fp);
	_read_file(info->state,20,fp);
	_read_file(info->zip,20,fp);
	_read_file(info->country,20,fp);
	_read_file(info->email,50,fp);
	_read_file(info->notes[0],50,fp);
	_read_file(info->notes[1],50,fp);
	_read_file(info->notes[2],50,fp);
	_read_file(info->notes[3],50,fp);
	
	fclose(fp);
	return TRUE;
}

int delete_info(int number)
{
	FILE *fp;
	
	fp = fopen(current_file,"r+");
	
	fseek(fp,HOT_FILE_KEY_SIZE+HOT_FILE_REC_SIZE*(number - 1),SEEK_SET);
	
	fprintf(fp,"%9d",number*(-1));
	fflush(fp);
	
	fclose(fp);
	
	class_listup();
	
	return TRUE;
}

int set_current(int number)
{
	read_info(number,&current_info);
	display_person_information();
}


int search_name(unsigned value, char *firstname, char *lastname)
{
	unsigned flag;
	Class_field	*class_p;
	Number_field	*num_p;

	list_clear(Hot_name_search->entrylist);

	_search_class_field(class_head,value,firstname,lastname);
	
	return TRUE;
}

int  _search_class_field(Class_field *class_p,unsigned value,char *firstname,char *lastname)
{
	if(class_p == NULL)
		return TRUE;
	
	if(class_p->forward != NULL)
		_search_class_field(class_p->forward,value,firstname,lastname);
	_search_number_field(class_p->num_p,value,firstname,lastname);
	if(class_p->backward != NULL)
		_search_class_field(class_p->backward,value,firstname,lastname);
	
	return TRUE;
}

int  _search_number_field(Number_field *num_p,unsigned value,char *firstname,char *lastname)
{
	int flag;
	
	flag = 0;
	
	if(num_p->forward != NULL)
		_search_number_field(num_p->forward,value,firstname,lastname);
	if(value & 1) {
		if(!strcmp(firstname,num_p->first)) {
			flag |= 1;
		}
	} else {
		flag |= 1;
	}
	
	if((value >> 1) & 1) {
		if(!strcmp(lastname,num_p->last)) {
			flag |= 2;
		}
	} else {
		flag |= 2;
	}
	
	if(flag == 3) 
		entrylist_insert(Hot_name_search->entrylist,num_p->first,num_p->last,num_p->number);
	
	if(num_p->backward != NULL)
		_search_number_field(num_p->backward,value,firstname,lastname);
	
	return TRUE;
}

int search_phone(unsigned value,char countrycode[12],char areacode[12],char phone[17])
{
	int number;
	unsigned flag;
	Person_information info;
	
	list_clear(Hot_phone_search->entrylist);
	
	number = 1;
		
	while(read_info(number++,&info) != EOF) {
		flag = 0;
		if((value >> 2) & 1) {
			if(!strcmp(phone,info.phone))
				flag |= 1;
			else 
				continue;
		} else {
			flag |= 1;
		}
		if((value >> 1) & 1) {
			if(!strcmp(areacode,info.areacode))
				flag |= 2;
			else 
				continue;
		} else {
			flag |= 2;
		}
		if(value & 1) {
			if(!strcmp(countrycode,info.countrycode))
				flag |= 4;
			else 
				continue;
		} else {
			flag |= 4;
		}
		if(flag == 7)
			entrylist_insert(Hot_phone_search->entrylist,info.first,info.last,info.number);
	}		
 	
 	return TRUE;
 }
 
int search_address(unsigned value,char address[42],char city[42],char state[22],char zip[22],char country[22])
{
	int number;
	unsigned flag;
	Person_information info;
	
	list_clear(Hot_address_search->entrylist);
	
	number = 1;
	
	while(read_info(number++,&info) != EOF) {
		flag = 0;
		if(value & 1) {
			if(!strcmp(address,info.address))
				flag |= 1;
			else 
				continue;
		} else {
			flag |= 1;
		}
		if((value >> 1) & 1) {
			if(!strcmp(city,info.city))
				flag |= 2;
			else
				continue;
		} else {
			flag |= 2;
		}
		if((value >> 2) & 1) {
			if(!strcmp(state,info.state))
				flag |= 4;
			else 
				continue;
		} else {
			flag |= 4;
		}
		if((value >> 3) & 1) {
			if(!strcmp(zip,info.zip))
				flag |= 8;
			else 
				continue;
		} else {
			flag |= 8;
		}
		if((value >> 4) & 1) {
			if(!strcmp(country,info.country))
				flag |= 16;
			else 
				continue;
		} else {
			flag |= 16;
		}
		if(flag == 31)
			entrylist_insert(Hot_address_search->entrylist,info.first,info.last,info.number);
	}
 	
 	return TRUE;
}

	 
int _read_file(char *item,int size,FILE *fp)
{
	int i,j,flag;
	int c;
	
	j = 0;  flag = 0;
	for(i = 1;i <= size;i++) {
		c = fgetc(fp);
		if(c == EOF) return EOF;
		if(c == ' ' && flag == 0) continue;
		flag = 1;
		item[j] = c;
		j++;
	}
	
	item[j] = '\0';
	
	return TRUE;
}


int _insert_to_field(char *class,char *firstname,char *lastname,int number)
{
	Number_field *num_p;

	class_head = _insert_to_class_field(class_head,class);

	matched_p->num_p = _insert_to_number_field(matched_p->num_p,firstname,lastname,number);

	return TRUE;
}

Number_field *_insert_to_number_field(Number_field *num_p,char *firstname,char *lastname,int number)
{
	if( num_p == NULL) {
		num_p = _allocate_number();
		num_p->forward = NULL;
		num_p->backward = NULL;
		num_p->number = number;
		strcpy(num_p->first,firstname);
		strcpy(num_p->last,lastname);
	}
	else if(strcmp(lastname,num_p->last) == 0) {
		if(strcmp(firstname,num_p->first) < 0)
			num_p->forward = _insert_to_number_field(num_p->forward,firstname,lastname,number);
		else	
			num_p->backward = _insert_to_number_field(num_p->backward,firstname,lastname,number);
	}
	else if(strcmp(lastname,num_p->last) < 0)
		num_p->forward = _insert_to_number_field(num_p->forward,firstname,lastname,number);
	else
		num_p->backward = _insert_to_number_field(num_p->backward,firstname,lastname,number);
		
	return (num_p);
}

Class_field  *_insert_to_class_field(Class_field *class_p,char *class)
{
	if( class_p == NULL) {
		class_p = _allocate_class();
		class_p->forward = NULL;
		class_p->backward = NULL;
		class_p->num_p = NULL;
		strcpy(class_p->class,class);
		matched_p = class_p;
	}
	else if(strcmp(class,class_p->class) == 0) 
		matched_p = class_p;
	else if(strcmp(class,class_p->class) < 0) 
		class_p->forward = _insert_to_class_field(class_p->forward,class);
	else 
		class_p->backward = _insert_to_class_field(class_p->backward,class);
	
	return (class_p);
}

Class_field *_allocate_class(void)
{
	return((Class_field *)malloc(sizeof(Class_field)));
}

Number_field *_allocate_number(void)
{
	return((Number_field *)malloc(sizeof(Number_field)));
}

int  _free_field(Class_field *class_p)
{
	if(class_p == NULL)
		return TRUE;
	
	if(class_p->forward != NULL)
		_free_field(class_p->forward);
	_free_number_field(class_p->num_p);
	if(class_p->backward != NULL)
		_free_field(class_p->backward);
	free(class_p);
	
	return TRUE;
}

int  _free_number_field(Number_field *num_p)
{
	if(num_p == NULL)
		return TRUE;
	
	if(num_p->forward != NULL)
		_free_number_field(num_p->forward);
	if(num_p->backward != NULL)
		_free_number_field(num_p->backward);
	free(num_p);
	
	return TRUE;
}


/*  Modem command functions */

void open_modem_setting_file(void)
{
	FILE *fp;
	
	retry:
	
	fp = fopen(modem_setting_file,"r");
	if ( fp == NULL ) {
		notice("Can't open setting file.\nCreate new file.",NOTICE_TYPE_OK,"Dismiss","");
		fclose(fp);
		_create_modem_setting_file();
		goto retry;
	}
	
	fscanf(fp,MODEM_SETTING_FILE_FORMAT,modem.prefixcode,modem.modemdev,&modem.toneorpuls);

	display_modem_setting();
}
 

void _create_modem_setting_file(void)
{
	FILE *fp;
	
	fp = fopen(modem_setting_file,"w");
	if ( fp == NULL ) {
		notice("Can't create setting file. Exit.",NOTICE_TYPE_OK,"Dismiss","");
		xv_destroy_safe(Hot_parent->frame);
		exit(0);
	}
	
	fprintf(fp,MODEM_SETTING_FILE_FORMAT,
		MODEM_ST_PREFIX,
		MODEM_ST_DEVICE,
		MODEM_ST_TORP);
	
	fclose(fp);
}
	
void update_modem_setting_file(void)
{
	FILE *fp;
	
	fp = fopen(modem_setting_file,"r+");
	if ( fp == NULL ) {
		notice("Can't open setting file.\nUpdate was canceled.",NOTICE_TYPE_OK,"Dismiss","");
		fclose(fp);
		return;
	}
	
	fprintf(fp,MODEM_SETTING_FILE_FORMAT,modem.prefixcode,modem.modemdev,modem.toneorpuls);
	
	fclose(fp);
}

char *generated_num(void)
{
	char *number;
	
	if ((number = (char *) calloc(256,sizeof(char))) == NULL)
		return (NULL);
	                      
	
	switch ( current_info.area ) {
	case 0:
		sprintf(number,"%s",current_info.phone);
		break;
	case 1:
		sprintf(number,"%s-%s",current_info.areacode,current_info.phone);
		break;
	case 2:
		sprintf(number,"%s-%s-%s-%s",modem.prefixcode,current_info.countrycode,
					current_info.areacode,current_info.phone);
		break;
	}
	
	return (number);
}
