#ifndef DIAL_H
#define DIAL_H

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include <fcntl.h>         
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <termios.h>

#include "hotpage.h"
#include "display.h"
#include "type.h"

#define BUFSIZE 1024
#define SNDBUFSIZE 1024

#define MODEM_ST_PREFIX "011"
#define MODEM_ST_DEVICE "/dev/modem"
#define MODEM_ST_TORP 0


enum  cchar {
	NUL, SOH, STX, ETX, EOT, ENQ, ACK, BEL, BS,  HT,  LF,
	VT,  FF,  CR,  SO,  SI,  DLE, XON, DC2, XOFF,DC4, NAK,
	SYN, ETB, CAN, EM,  SUB, ESC, FS,  GS,  RS,  US } ;
       
unsigned char normalbits [ 256 ];

typedef struct {
	int modem; /* modemfile descriptor */
	char prefixcode[20]; /* international call prefix code */
	char modemdev[256]; /* modem device filename */
	int toneorpuls;
} modemset;

modemset modem;

extern int open_modem(void);
extern int dial_start(char *telnum);
extern int close_modem(void);

#endif
